using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Promotions;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IPromotionRepository
    {
        Task<BaseResult> Add(PromotionElastic Promotion);

        Task<BaseResult> AddManyAsync(IEnumerable<PromotionElastic> Promotions);

        Task<SmartTableResult<PromotionElastic>> Search(BoolQueryDescriptor<PromotionElastic> query);

        Task<SmartTableResult<PromotionElastic>> GetByIds(List<long> ids);

        Task<SmartTableResult<PromotionElastic>> GetAll();
    }

    public class PromotionRepository : IPromotionRepository
    {
        private readonly ElasticIndex<PromotionElastic> _dbContext;

        public PromotionRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<PromotionElastic>(settings.Value.ClusterUrl, "inventorypromotion");
        }

        public async Task<SmartTableResult<PromotionElastic>> Search(BoolQueryDescriptor<PromotionElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(PromotionElastic Promotion)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(Promotion);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<PromotionElastic> Promotions)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(Promotions);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<PromotionElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<PromotionElastic>();
            var idsQ = new QueryContainerDescriptor<PromotionElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        public async Task<SmartTableResult<PromotionElastic>> GetAll()
        {
            var query = new BoolQueryDescriptor<PromotionElastic>();
            var isdeletedQ = new QueryContainerDescriptor<PromotionElastic>();
            isdeletedQ.Terms(t => t.Field(f => f.IsDeleted).Terms(false));
            query.Filter(f => isdeletedQ);
            return await _dbContext.Search(query);
        }
    }
}